# -*- coding: binary -*-
require 'rex/post/meterpreter'

module Rex
module Post
module Meterpreter
module Ui

###
#
# Oracle hooking extension
#
###
class Console::CommandDispatcher::Oralog

	Klass = Console::CommandDispatcher::Oralog

	include Console::CommandDispatcher

	#
	# Initializes an instance.
	#
	def initialize(shell)
		super
	end

	#
	# List of supported commands.
	#
	def commands
		{
			"hook" => "Hook all critical functions",
			"unhook" => "Unhook the redirected functions",
			"hookPZTVO5PE" => "Hook the PZTVO5PE function",
			"hookPZTVO5PD" => "Hook the PZTVO5PD function",
            "unhookPZTVO5PE" => "Unhook the PZTVO5PE function",
			"unhookPZTVO5PD" => "Unhook the PZTVO5PD function",
			"getlogfile" => "Read and dump the content of the logfile",
			"setlogfile" => "Set the log file name and location (default value is c:\\\\TEMP\\\\ocioralog. Please note that you have to use double backslashes!"
		}
	end

	
	def cmd_hook()
		response=client.oralog.oralog_hook()
		print_line(response['response'])
		return true
	end

	def cmd_unhook()
		response=client.oralog.oralog_unhook()
		print_line(response['response'])
		return true
	end

	def cmd_hookPZTVO5PE()
		response=client.oralog.oralog_hookpztvo5pe()
		print_line(response['response'])
		return true
	end


	def cmd_hookPZTVO5PD()
		response=client.oralog.oralog_hookpztvo5pd()
		print_line(response['response'])
		return true
	end

    def cmd_unhookPZTVO5PE()
		response=client.oralog.oralog_unhookpztvo5pe()
		print_line(response['response'])
		return true
	end

	def cmd_unhookPZTVO5PD()
		response=client.oralog.oralog_unhookpztvo5pd()
		print_line(response['response'])
		return true
	end


	def cmd_getlogfile()
		response=client.oralog.oralog_getlogfile()
		print_line(response['response'])
		return true
	end

	def cmd_setlogfile(*args)
		print_line("Argument: "+args[0])
		response=client.oralog.oralog_setlogfile(args[0])
		print_line(response['response'])
		return true
	end

	#
	# Name for this dispatcher
	#
	def name
		"Oralog"
	end

end

end
end
end
end
